/**
 * penguins-eggs-v8
 * author: Piero Proietti
 * email: piero.proietti@gmail.com
 * license: MIT
 */
/**
 * Utils: general porpourse utils
 * @remarks all the utilities
 */
export default class Debian {
    static debs4calamares: string[];
    /**
     * check if it's installed xorg
     * @returns true if xorg is installed
     */
    static isInstalledXorg(): boolean;
    /**
     * check if it's installed wayland
     * @returns true if wayland
     */
    static isInstalledWayland(): boolean;
    /**
     * Crea array packages dei pacchetti da installare
     */
    static packages(remove?: boolean, verbose?: boolean): string[];
    /**
     *
     */
    static prerequisitesInstall(verbose?: boolean): Promise<boolean>;
    /**
     * Torna verso se calamares è installato
     */
    static calamaresCheck(): Promise<boolean>;
    /**
     *
     */
    static liveInstallerPolicies(): Promise<void>;
    /**
     *
     */
    static calamaresInstall(verbose?: boolean): Promise<void>;
    /**
     * calamaresPolicies
     */
    static calamaresPolicies(): Promise<void>;
    /**
     *
     */
    static calamaresRemove(verbose?: boolean): Promise<boolean>;
    /**
     * restuisce VERO se il pacchetto è installato
     * @param debPackage
     */
    static packageIsInstalled(debPackage: string): boolean;
    /**
     * Install the package packageName
     * @param packageName {string} Pacchetto Debian da installare
     * @returns {boolean} True if success
     */
    static packageInstall(packageName: string): Promise<boolean>;
    /**
     * restuisce VERO se il pacchetto è installato
     * @param debPackage
     */
    static packageAptAvailable(packageName: string): Promise<boolean>;
    static packageAptLast(debPackage: string): Promise<string>;
}
