"use strict";
/**
 * penguins-eggs: buster.ts
 *
 * it work both: buster, bullseye
 *
 * author: Piero Proietti
 * mail: piero.proietti@gmail.com
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Buster = void 0;
const tslib_1 = require("tslib");
const fisherman_1 = tslib_1.__importDefault(require("../fisherman"));
/**
 *
 */
class Buster {
    /**
     * @param remix
     * @param distro
     * @param displaymanager
     * @param verbose
     */
    constructor(installer, remix, distro, release, user_opt, verbose = false) {
        this.verbose = false;
        this.installer = {};
        this.release = false;
        this.installer = installer;
        this.remix = remix;
        this.distro = distro;
        this.user_opt = user_opt;
        this.verbose = verbose;
        this.release = release;
    }
    /**
     *
     */
    async create() {
        const fisherman = new fisherman_1.default(this.distro, this.installer, this.verbose);
        await fisherman.settings(this.remix.branding);
        await fisherman.buildModule('partition', this.remix.branding);
        await fisherman.buildModule('mount');
        await fisherman.moduleUnpackfs();
        await fisherman.buildCalamaresModule('dpkg-unsafe-io', true);
        await fisherman.buildCalamaresModule('sources-yolk', true);
        await fisherman.buildModule('machineid');
        await fisherman.buildModule('fstab');
        await fisherman.buildModule('locale');
        await fisherman.buildModule('keyboard');
        await fisherman.buildModule('localecfg');
        await fisherman.buildModule('users');
        await fisherman.moduleDisplaymanager();
        await fisherman.buildModule('networkcfg');
        await fisherman.buildModule('hwclock');
        await fisherman.buildModule('services-systemd');
        await fisherman.buildCalamaresModule('bootloader-config', true);
        await fisherman.buildModule('grubcf');
        await fisherman.buildModule('bootloader');
        await fisherman.modulePackages(this.distro, this.release);
        await fisherman.buildModule('luksbootkeyfile');
        await fisherman.buildModule('plymouthcfg');
        await fisherman.buildModule('initramfscfg');
        await fisherman.buildModule('initramfs');
        await fisherman.moduleRemoveuser(this.user_opt);
        await fisherman.buildCalamaresModule('dpkg-unsafe-io-undo', false);
        await fisherman.buildCalamaresModule('sources-yolk-unmount', false);
        await fisherman.buildCalamaresModule('cleanup', true);
        await fisherman.buildModule('umount');
        await fisherman.moduleFinished();
    }
}
exports.Buster = Buster;
