"use strict";
/**
 * penguins-eggs: focal.ts
 * used for: groovy, hirsute
 * author: Piero Proietti
 * mail: piero.proietti@gmail.com
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Focal = void 0;
const tslib_1 = require("tslib");
const fisherman_1 = tslib_1.__importDefault(require("../fisherman"));
/**
 *
 */
class Focal {
    /**
     * @param remix
     * @param distro
     * @param displaymanager
     * @param verbose
     */
    constructor(installer, remix, distro, release, user_opt, verbose = false) {
        this.verbose = false;
        this.installer = {};
        this.release = false;
        this.installer = installer;
        this.remix = remix;
        this.distro = distro;
        this.user_opt = user_opt;
        this.verbose = verbose;
        this.release = release;
    }
    /**
     *
     */
    async create() {
        const fisherman = new fisherman_1.default(this.distro, this.installer, this.verbose);
        // console.log('creating settings: ' + this.remix.branding)
        await fisherman.settings(this.remix.branding);
        // console.log('creating modules: ' + this.remix.branding)
        await fisherman.buildModule('partition', this.remix.branding);
        await fisherman.buildModule('mount');
        await fisherman.moduleUnpackfs();
        await fisherman.buildCalamaresModule('sources-yolk', true);
        await fisherman.buildModule('machineid');
        await fisherman.buildModule('fstab');
        await fisherman.buildModule('locale');
        await fisherman.buildModule('keyboard');
        await fisherman.buildModule('localecfg');
        await fisherman.buildModule('luksbootkeyfile');
        await fisherman.buildModule('users');
        await fisherman.moduleDisplaymanager();
        await fisherman.buildModule('networkcfg');
        await fisherman.buildModule('hwclock');
        await fisherman.contextualprocess('before_bootloader_mkdirs');
        await fisherman.shellprocess('bug-LP#1829805');
        await fisherman.buildModule('initramfs');
        await fisherman.buildModule('grubcfg');
        await fisherman.contextualprocess('before_bootloader');
        await fisherman.buildModule('bootloader');
        await fisherman.contextualprocess('after_bootloader');
        await fisherman.shellprocess('add386arch');
        await fisherman.modulePackages(this.distro, this.release); //
        await fisherman.moduleRemoveuser(this.user_opt);
        await fisherman.buildCalamaresModule('sources-yolk', false);
        await fisherman.buildCalamaresModule('sources-yolk-unmount', false);
        await fisherman.buildCalamaresModule('cleanup', true);
        await fisherman.buildModule('umount');
        await fisherman.buildModule('finished');
    }
}
exports.Focal = Focal;
