"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryInstall = exports.remove = void 0;
const tslib_1 = require("tslib");
/**
 *
 */
const pacman_1 = tslib_1.__importDefault(require("../../pacman"));
/**
 *
 */
function remove(distro) {
    let remove = true;
    let removePackages = pacman_1.default.packages(remove);
    if (distro.distroLike === 'Arch') {
        removePackages = ["calamares"];
        removePackages = ["penguins-eggs"];
    }
    else {
        removePackages.push("calamares");
        removePackages.push("eggs");
    }
    const mustRemain = ["coreutils", "cryptsetup", "curl", "dosfstools", "git", "parted", "rsync", "lvm2"];
    let sorted = [];
    for (const elem of removePackages) {
        if (!mustRemain.includes(elem)) {
            sorted.push(elem);
        }
    }
    sorted = sorted.sort();
    let text = '  - remove:\n';
    for (const elem of sorted) {
        text += `    - ${elem.trim()}\n`;
    }
    return text;
}
exports.remove = remove;
/**
 *
 * @param distro
   - try_install:
      - language-pack-$LOCALE
      - hunspell-$LOCALE
      - libreoffice-help-$LOCALE

 */
function tryInstall(distro) {
    let packages = '';
    /**
     * Depending on the distro
     */
    if (distro.distroLike === 'Ubuntu') {
        packages += '    - language-pack-$LOCALE\n';
    }
    // Da localizzare se presenti
    if (pacman_1.default.packageIsInstalled('hunspell')) {
        packages += '    - hunspell-$LOCALE\n';
    }
    if (pacman_1.default.packageIsInstalled('libreoffice-base-core')) {
        packages += `    - libreoffice-l10n-$LOCALE\n`;
        packages += `    - libreoffice-help-$LOCALE\n`;
    }
    if (pacman_1.default.packageIsInstalled('firefox-esr')) {
        packages += `    - firefox-esr-$LOCALE\n`;
    }
    if (pacman_1.default.packageIsInstalled('firefox')) {
        packages += `    - firefox-$LOCALE\n`;
    }
    if (pacman_1.default.packageIsInstalled('thunderbird')) {
        packages += `    - thunderbird-locale-$LOCALE\n`;
    }
    let retVal = '';
    if (packages !== '') {
        retVal += '  - try_install:\n' + packages;
    }
    return retVal;
}
exports.tryInstall = tryInstall;
