"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.installer = void 0;
const tslib_1 = require("tslib");
const distro_1 = tslib_1.__importDefault(require("../../classes/distro"));
const pacman_1 = tslib_1.__importDefault(require("../../classes/pacman"));
function installer() {
    const installer = {};
    if (pacman_1.default.packageIsInstalled('calamares')) {
        installer.name = 'calamares';
        installer.configuration = '/etc/calamares/';
        installer.multiarch = multiarch() + 'calamares/';
    }
    else {
        installer.name = 'krill';
        installer.configuration = '/etc/penguins-eggs.d/krill/';
        installer.multiarch = multiarch() + 'penguins-eggs/';
    }
    installer.modules = installer.configuration + 'modules/';
    installer.multiarchModules = installer.multiarch + 'modules/';
    /**
     * i template nelle versioni isCalamaresAvailable sono QUELLI di calamares
     */
    const remix = {};
    const distro = new distro_1.default(remix);
    if (distro.isCalamaresAvailable) {
        installer.template = '/etc/penguins-eggs.d/distros/' + distro.codenameLikeId + '/calamares/';
        installer.templateModules = installer.template + 'modules/';
        installer.templateMultiarch = installer.template + 'calamares-modules/';
    }
    else {
        installer.template = '/etc/penguins-eggs.d/distros/' + distro.codenameLikeId + '/krill/';
        installer.templateModules = installer.template + 'modules/';
        installer.templateMultiarch = installer.template + 'krill-modules/';
    }
    return installer;
}
exports.installer = installer;
/**
 *
 * @returns
 */
function multiarch() {
    return pacman_1.default.distro().usrLibPath;
}
