import { IXkbModel, IXkbLayout, IXkbVariant, IXkbOption } from '../interfaces/i-xkb-model';
/**
 * /usr/share/X11/xkb/rules/xorg.lst
 */
export default class Keyboard {
    models: string[];
    layouts: string[];
    variants: string[];
    options: string[];
    constructor();
    /**
     * XKBMODEL[]
     */
    getModels(): IXkbModel[];
    /**
     * XKBLAYOUT=[]
     */
    getLayouts(): IXkbLayout[];
    /**
     * IXkbVariant[]
     */
    getVariants(layout: string): IXkbVariant[];
    /**
     * XKBOPTIONS[]
     */
    getOptions(): IXkbOption[];
    /**
     * XKBMODEL='pc105'
     */
    getModel(): Promise<string>;
    /**
     * XKBLAYOUT='us'
     */
    getLayout(): Promise<string>;
    /**
     * XKBVARIANT=''
     */
    getVariant(): Promise<string>;
    /**
     * XKBOPTIONS=''
     */
    getOption(): Promise<string>;
}
