/**
 * penguins-eggs: ovary.ts
 * author: Piero Proietti
 * mail: piero.proietti@gmail.com
 *
 */
import { IMyAddons } from '../interfaces';
import Incubator from './incubation/incubator';
import Settings from './settings';
import Users from './users';
/**
 * Ovary:
 */
export default class Ovary {
    verbose: boolean;
    echo: {};
    toNull: string;
    incubator: Incubator;
    settings: Settings;
    familyId: string;
    snapshot_prefix: string;
    snapshot_basename: string;
    compression: string;
    clone: boolean;
    /**
     * @returns {boolean} success
     */
    fertilization(snapshot_prefix?: string, snapshot_basename?: string, theme?: string, compression?: string): Promise<boolean>;
    /**
     *
     * @param basename
     */
    produce(backup: boolean | undefined, clone: boolean | undefined, scriptOnly: boolean | undefined, yolkRenew: boolean | undefined, release: boolean | undefined, myAddons: IMyAddons, verbose?: boolean): Promise<void>;
    /**
     * Crea la struttura della workdir
     */
    liveCreateStructure(): Promise<void>;
    /**
     *
     * @param cmd
     */
    tryCatch(cmd?: string): Promise<void>;
    /**
     * editLiveFs
     * - Truncate logs, remove archived log
     * - Allow all fixed drives to be mounted with pmount
     * - Enable or disable password login trhough ssh for users (not root)
     * - Create an empty /etc/fstab
     * - Blanck /etc/machine-id
     * - Add some basic files to /dev
     * - Clear configs from /etc/network/interfaces, wicd and NetworkManager and netman
     */
    editLiveFs(): Promise<void>;
    /**
     * syslinux
     */
    syslinux(): Promise<void>;
    /**
     *  async isolinux
     */
    isolinux(theme?: string): Promise<void>;
    /**
     * copy kernel
     */
    kernelCopy(): Promise<void>;
    /**
     * necessita di echoYes
     */
    initrdCreate(): Promise<void>;
    /**
     * We must upgrade to initrdCreate for Debian/Ubuntu
     * @returns
     */
    initrdCopy(verbose?: boolean): Promise<void>;
    /**
     * squashFs: crea in live filesystem.squashfs
     */
    makeSquashfs(scriptOnly?: boolean): Promise<void>;
    /**
     * Restituisce true per le direcory da montare con overlay
     *
     * Ci sono tre tipologie:
     *
     * - normal solo la creazione della directory, nessun mount
     * - merged creazione della directory e mount ro
     * - mergedAndOverlay creazione directory, overlay e mount rw
     *
     * @param dir
     */
    mergedAndOvelay(dir: string): boolean;
    /**
     * Ritorna true se c'è bisogno del mount --bind
     *
     * Ci sono tre tipologie:
     *
     * - normal solo la creazione della directory, nessun mount
     * - merged creazione della directory e mount ro
     * - mergedAndOverlay creazione directory, overlay e mount rw
     */
    merged(dir: string): boolean;
    /**
     * Esegue il bind del fs live e
     * crea lo script bind
     *
     * @param verbose
     */
    bindLiveFs(): Promise<void>;
    /**
     * ubind del fs live
     * @param verbose
     */
    uBindLiveFs(): Promise<void>;
    /**
     * bind dei virtual file system
     */
    bindVfs(): Promise<void>;
    /**
     *
     * @param verbose
     */
    ubindVfs(): Promise<void>;
    /**
     *
     * @param verbose
     */
    cleanUsersAccounts(): Promise<void>;
    /**
     * list degli utenti: grep -E 1[0-9]{3}  /etc/passwd | sed s/:/\ / | awk '{print $1}'
     * create la home per user_opt
     * @param verbose
     */
    createUserLive(): Promise<void>;
    /**
     *
     */
    createXdgAutostart(theme: string | undefined, myAddons: IMyAddons): Promise<void>;
    /**
     * Creazione link desktop per lxde
     * @param name
     * @param icon
     */
    private lxdeLink;
    /**
     * Add or remove exclusion
     * @param add {boolean} true = add, false remove
     * @param exclusion {atring} path to add/remove
     */
    addRemoveExclusion(add: boolean, exclusion: string): void;
    /**
     * makeEfi
    */
    makeEfi(theme?: string): Promise<void>;
    /**
     * makeDotDisk
     * create .disk/info, .disk/mksquashfs, .disk/mkiso
     * return mkiso
     */
    makeDotDisk(backup?: boolean): string;
    /**
     *
     * @param backup
     * @returns cmd 4 mkiso
     */
    xorrisoCommand(backup?: boolean): string;
    /**
     * makeIso
     * cmd: cmd 4 xorirriso
     */
    makeIso(cmd: string, scriptOnly?: boolean): Promise<void>;
    /**
     * finished = show the results
     * @param scriptOnly
     */
    finished(scriptOnly?: boolean): void;
    /**
    * fill
    */
    usersFill(): Promise<Users[]>;
}
