"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const core_1 = require("@oclif/core");
const tools_1 = tslib_1.__importDefault(require("../../classes/tools"));
const utils_1 = tslib_1.__importDefault(require("../../classes/utils"));
const utils_2 = require("../../lib/utils");
class ExportDeb extends core_1.Command {
    async run() {
        const { args, flags } = await this.parse(ExportDeb);
        utils_1.default.titles(this.id + ' ' + this.argv);
        const Tu = new tools_1.default();
        utils_1.default.warning(ExportDeb.description);
        await Tu.loadSettings();
        // rimozione
        if (flags.clean) {
            console.log('cleaning remote host');
            let arch = utils_1.default.eggsArch();
            if (flags.all) {
                arch = '*';
            }
            arch += '.deb';
            const cmd = 'ssh ' + Tu.config.remoteUser + '@' + Tu.config.remoteHost + ' rm -rf ' + Tu.config.remotePathDeb + Tu.config.filterDeb + arch;
            await (0, utils_2.exec)(cmd, { echo: true, capture: true });
        }
        // esportazione
        console.log('copy to remote host...');
        let arch = utils_1.default.eggsArch();
        if (flags.all) {
            arch = '*';
        }
        arch += '.deb';
        const cmd = 'scp ' + Tu.config.localPathDeb + Tu.config.filterDeb + arch + ' root@' + Tu.config.remoteHost + ':' + Tu.config.remotePathDeb;
        await (0, utils_2.exec)(cmd, { echo: true, capture: true });
    }
}
exports.default = ExportDeb;
ExportDeb.description = 'export deb/docs/iso to the destination host';
ExportDeb.flags = {
    help: core_1.Flags.help({ char: 'h' }),
    clean: core_1.Flags.boolean({ char: 'c', description: 'remove old .deb before to copy' }),
    amd64: core_1.Flags.boolean({ description: 'export amd64 arch' }),
    i386: core_1.Flags.boolean({ description: 'export i386 arch' }),
    armel: core_1.Flags.boolean({ description: 'export armel arch' }),
    arm64: core_1.Flags.boolean({ description: 'export arm64 arch' }),
    all: core_1.Flags.boolean({ char: 'a', description: 'export all archs' })
};
