"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const core_1 = require("@oclif/core");
const tools_1 = tslib_1.__importDefault(require("../../classes/tools"));
const utils_1 = tslib_1.__importDefault(require("../../classes/utils"));
const utils_2 = require("../../lib/utils");
class ExportDocs extends core_1.Command {
    async run() {
        const { args, flags } = await this.parse(ExportDocs);
        const Tu = new tools_1.default();
        utils_1.default.titles(this.id + ' ' + this.argv);
        utils_1.default.warning(ExportDocs.description);
        await Tu.loadSettings();
        await (0, utils_2.exec)(`ssh ${Tu.config.remoteUser}@${Tu.config.remoteHost} rm -rf ${Tu.config.remotePathDoc}*`, { echo: true, capture: true });
        await (0, utils_2.exec)(`scp -r ${Tu.config.localPathDoc}/* ${Tu.config.remoteUser}@${Tu.config.remoteHost}:${Tu.config.remotePathDoc}`, { echo: true, capture: true });
    }
}
exports.default = ExportDocs;
ExportDocs.description = 'remove and export docType documentation of the sources in the destination host';
ExportDocs.flags = {
    help: core_1.Flags.help({ char: 'h' })
};
