"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 *
 */
const core_1 = require("@oclif/core");
const tools_1 = tslib_1.__importDefault(require("../../classes/tools"));
const utils_1 = tslib_1.__importDefault(require("../../classes/utils"));
const utils_2 = require("../../lib/utils");
class ExportIso extends core_1.Command {
    async run() {
        const { flags } = await this.parse(ExportIso);
        utils_1.default.titles(this.id + ' ' + this.argv);
        const Tu = new tools_1.default();
        utils_1.default.warning(ExportIso.description);
        await Tu.loadSettings();
        if (flags.backup) {
            Tu.snapshot_name = Tu.snapshot_name.slice(0, 7) === 'egg-of-' ? 'egg-eb-' + Tu.snapshot_name.slice(7) : 'backup-' + Tu.snapshot_name;
        }
        let cmd = `ssh root@${Tu.config.remoteHost} rm -rf ${Tu.config.remotePathIso}${Tu.snapshot_name}*`;
        if (flags.clean) {
            utils_1.default.warning('cleaning destination...');
            await (0, utils_2.exec)(cmd, { echo: true, capture: true });
        }
        utils_1.default.warning('copy to destination...');
        cmd = `scp ${Tu.snapshot_dir}${Tu.snapshot_name}* root@${Tu.config.remoteHost}:${Tu.config.remotePathIso}`;
        await (0, utils_2.exec)(cmd, { echo: true, capture: true });
    }
}
exports.default = ExportIso;
ExportIso.description = 'export iso in the destination host';
ExportIso.flags = {
    help: core_1.Flags.help({ char: 'h' }),
    backup: core_1.Flags.boolean({ char: 'b', description: 'export backup ISOs' }),
    clean: core_1.Flags.boolean({ char: 'c', description: 'delete old ISOs before to copy' })
};
