"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * penguins-eggs-v7 based on Debian live
 * author: Piero Proietti
 * email: piero.proietti@gmail.com
 * license: MIT
 */
const core_1 = require("@oclif/core");
const utils_1 = tslib_1.__importDefault(require("../classes/utils"));
const settings_1 = tslib_1.__importDefault(require("../classes/settings"));
const utils_2 = require("../lib/utils");
class Kill extends core_1.Command {
    constructor() {
        super(...arguments);
        this.config_file = '/etc/penguins-eggs.d/eggs.yaml';
        this.snapshot_dir = '';
        this.work_dir = {};
    }
    async run() {
        await utils_1.default.titles(this.id + ' ' + this.argv);
        const { flags } = await this.parse(Kill);
        let verbose = false;
        if (flags.verbose) {
            verbose = true;
        }
        const echo = utils_1.default.setEcho(verbose);
        if (utils_1.default.isRoot()) {
            // Utils.warning('Cleaning the nest...')
            const settings = new settings_1.default();
            await settings.load();
            await settings.listFreeSpace();
            if (await utils_1.default.customConfirm()) {
                await (0, utils_2.exec)(`rm ${settings.work_dir.path}/* -rf`, echo);
                await (0, utils_2.exec)(`rm ${settings.config.snapshot_dir} -rf`, echo);
            }
        }
        else {
            utils_1.default.useRoot(this.id);
        }
    }
}
exports.default = Kill;
Kill.description = 'kill the eggs/free the nest';
Kill.flags = {
    help: core_1.Flags.help({ char: 'h' }),
    verbose: core_1.Flags.boolean({ char: 'v', description: 'verbose' })
};
Kill.examples = ['$ eggs kill\nkill the eggs/free the nest'];
