/**
 * penguins-eggs-v9
 * author: Piero Proietti
 * email: piero.proietti@gmail.com
 * license: MIT
 */
/**
 *
 * syncfrom (restore)
 * --include-from file.list // if only include is provided everything from the list if used to update the system.
 * --exclude-from file-list // it just updates the system
 * --delete
 *
* If both options are provided then it works as a combination as provided in the link above.
* https://stackoverflow.com/questions/19296190/rsync-include-from-vs-exclude-from-what-is-the-actual-difference
*
 * The same logic is applied for the syncto also.
 *
 * On top of all of this the --delete option
 * if needed to be passed so that everything else is removed, but this
 * this should not be available by default
 */
import { Command } from '@oclif/core';
import Users from '../classes/users';
/**
 *
 */
export default class Syncto extends Command {
    verbose: boolean;
    echo: {};
    luksName: string;
    luksFile: string;
    luksDevice: string;
    luksMountpoint: string;
    static description: string;
    static flags: {
        delete: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
        file: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined>;
        help: import("@oclif/core/lib/interfaces").BooleanFlag<void>;
        verbose: import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
    };
    static examples: string[];
    /**
     *
     */
    run(): Promise<void>;
    /**
     *
     */
    backup(destDelete?: boolean): Promise<void>;
    /**
    * usersFill
    */
    usersFill(): Promise<Users[]>;
    /**
     *
     */
    luksCreate(): Promise<void>;
    /**
     *
     */
    luksOpen(): Promise<void>;
    /**
    *
    */
    luksClose(): Promise<void>;
}
