/**
 * penguins-eggs: krill
 *
 * author: Piero Proietti
 * mail: piero.proietti@gmail.com
 *
 */
import Locales from '../classes/locales';
import Keyboards from '../classes/keyboards';
import { INet } from '../interfaces';
import { IWelcome, ILocation, IKeyboard, IPartitions, IUsers } from '../interfaces/i-krill';
/**
 *
 */
export default class Krill {
    locales: Locales;
    keyboards: Keyboards;
    /**
     * @param cryped
     */
    prepare(cryped?: boolean, pve?: boolean, verbose?: boolean): Promise<void>;
    /**
     * WELCOME
     */
    welcome(): Promise<IWelcome>;
    /**
     * LOCATION
     */
    location(language: string): Promise<ILocation>;
    /**
    * KEYBOARD
    */
    keyboard(): Promise<IKeyboard>;
    /**
    * PARTITIONS
    */
    partitions(crypted?: boolean, pve?: boolean): Promise<IPartitions>;
    /**
     * USERS
     */
    users(): Promise<IUsers>;
    /**
     * Network
     */
    network(): Promise<INet>;
    /**
     * SUMMARY
     */
    summary(location: ILocation, keyboard: IKeyboard, partitions: IPartitions): Promise<void>;
    /**
     * INSTALL
     */
    install(location: ILocation, keyboard: IKeyboard, partitions: IPartitions, users: IUsers, network: INet, verbose?: boolean): Promise<void>;
    /**
     * return true if pv exist
     */
    private pvExist;
}
