"use strict";
/**
 * penguins-eggs: krill_sequence
 *
 * author: Piero Proietti
 * mail: piero.proietti@gmail.com
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const settings_1 = tslib_1.__importDefault(require("../classes/settings"));
const react_1 = tslib_1.__importDefault(require("react"));
const ink_1 = require("ink");
const install_1 = tslib_1.__importDefault(require("../components/install"));
const finished_1 = tslib_1.__importDefault(require("../components/finished"));
const fs_1 = tslib_1.__importDefault(require("fs"));
const js_yaml_1 = tslib_1.__importDefault(require("js-yaml"));
const shelljs_1 = tslib_1.__importDefault(require("shelljs"));
const utils_1 = tslib_1.__importDefault(require("../classes/utils"));
const cliAutologin = require("../lib/cli-autologin");
const pacman_1 = tslib_1.__importDefault(require("../classes/pacman"));
const installer_1 = require("../classes/incubation/installer");
const xdg_1 = tslib_1.__importDefault(require("../classes/xdg"));
const distro_1 = tslib_1.__importDefault(require("../classes/distro"));
const utils_2 = require("../lib/utils");
// import krill modules
const partitions_1 = tslib_1.__importDefault(require("./modules/partitions"));
const mount_fs_1 = require("./modules/mount-fs");
const mount_vfs_1 = require("./modules/mount-vfs");
const unpackfs_1 = tslib_1.__importDefault(require("./modules/unpackfs"));
const machine_id_1 = tslib_1.__importDefault(require("./modules/machine-id"));
const fstab_1 = tslib_1.__importDefault(require("./modules/fstab"));
const locale_1 = tslib_1.__importDefault(require("./modules/locale"));
const set_keyboard_1 = tslib_1.__importDefault(require("./modules/set-keyboard"));
const locale_cfg_1 = tslib_1.__importDefault(require("./modules/locale-cfg"));
// users
const add_user_1 = tslib_1.__importDefault(require("./modules/add-user"));
const change_password_1 = tslib_1.__importDefault(require("./modules/change-password"));
// displaymanager: autologin
const network_cfg_1 = tslib_1.__importDefault(require("./modules/network-cfg"));
// hwclock:
// services-systemd:
// bootloader-config
const bootloader_config_1 = tslib_1.__importDefault(require("./modules/bootloader-config"));
const bootloader_config_arch_1 = tslib_1.__importDefault(require("./modules/bootloader-config-arch"));
const bootloader_config_ubuntu_1 = tslib_1.__importDefault(require("./modules/bootloader-config-ubuntu"));
//
const grubcfg_1 = tslib_1.__importDefault(require("./modules/grubcfg"));
const bootloader_1 = tslib_1.__importDefault(require("./modules/bootloader"));
// packages: removeInstallerLink
const remove_installer_link_1 = tslib_1.__importDefault(require("./modules/remove-installer-link"));
// luksbootkeyfile:
// plymouthcfg;
const initramfs_cfg_1 = tslib_1.__importDefault(require("./modules/initramfs-cfg"));
const initramfs_1 = tslib_1.__importDefault(require("./modules/initramfs"));
const del_live_user_1 = tslib_1.__importDefault(require("./modules/del-live-user"));
// umount already imported
// to order in same wat
const set_timezone_1 = tslib_1.__importDefault(require("./modules/set-timezone"));
const umount_1 = tslib_1.__importDefault(require("./modules/umount"));
const mkfs_1 = tslib_1.__importDefault(require("./modules/mkfs"));
const hostname_1 = tslib_1.__importDefault(require("./modules/hostname"));
const hosts_1 = tslib_1.__importDefault(require("./modules/hosts"));
/**
 * hatching: installazione o cova!!!
 */
class Sequence {
    /**
     * constructor
     */
    constructor(location, keyboard, partitions, users, network) {
        this.partition = partitions_1.default;
        // mount
        this.mountFs = mount_fs_1.mountFs;
        this.mountVfs = mount_vfs_1.mountVfs;
        //
        this.unpackfs = unpackfs_1.default;
        this.machineId = machine_id_1.default;
        this.fstab = fstab_1.default;
        this.locale = locale_1.default;
        this.setKeyboard = set_keyboard_1.default;
        this.localeCfg = locale_cfg_1.default;
        // users
        this.addUser = add_user_1.default;
        this.changePassword = change_password_1.default;
        // displaumanager: autologin
        this.networkCfg = network_cfg_1.default;
        // hwclock:
        // services-systemd:
        // bootloader-config
        this.bootloaderConfig = bootloader_config_1.default;
        this.bootloaderConfigArch = bootloader_config_arch_1.default;
        this.bootloaderConfigUbuntu = bootloader_config_ubuntu_1.default;
        // 
        this.grubcfg = grubcfg_1.default;
        this.bootloader = bootloader_1.default;
        // packages: removeInstallerLink
        this.removeInstallerLink = remove_installer_link_1.default;
        // luksbootkeyfile:
        // plymouthcfg;
        this.initramfsCfg = initramfs_cfg_1.default;
        this.initramfs = initramfs_1.default;
        this.delLiveUser = del_live_user_1.default;
        this.umountFs = mount_fs_1.umountFs;
        this.umountVfs = mount_vfs_1.umountVfs;
        // to order in same wat
        this.setTimezone = set_timezone_1.default;
        this.umount = umount_1.default;
        this.mkfs = mkfs_1.default;
        this.hostname = hostname_1.default;
        this.hosts = hosts_1.default;
        this.installer = {};
        this.installTarget = '/tmp/calamares-krill-root';
        this.verbose = false;
        this.echo = {};
        this.efi = false;
        this.devices = {};
        this.users = {};
        this.network = {};
        this.partitions = {};
        this.language = '';
        this.region = '';
        this.zone = '';
        this.keyboardModel = '';
        this.keyboardLayout = '';
        this.keyboardVariant = '';
        this.toNull = ' > /dev/null 2>&1';
        this.settings = {};
        this.remix = {};
        this.distro = {};
        this.luksName = '';
        this.luksFile = '';
        this.luksDevice = '';
        this.luksMountpoint = '';
        this.personalFile = '';
        this.installer = (0, installer_1.installer)();
        this.settings = new settings_1.default();
        this.language = location.language;
        this.region = location.region;
        this.zone = location.zone;
        this.keyboardModel = keyboard.keyboardModel;
        this.keyboardLayout = keyboard.keyboardLayout;
        this.keyboardVariant = keyboard.keyboardVariant;
        this.network = network;
        this.partitions = partitions;
        this.users = users;
        this.devices.efi = {};
        this.devices.boot = {};
        this.devices.root = {};
        this.devices.data = {};
        this.devices.swap = {};
        this.distro = new distro_1.default(this.remix);
        this.efi = fs_1.default.existsSync('/sys/firmware/efi/efivars');
        // Per il restore dei dati
        this.luksName = 'luks-eggs-backup';
        this.luksFile = `/run/live/medium/live/${this.luksName}`;
        this.luksDevice = `/dev/mapper/${this.luksName}`;
        this.luksMountpoint = `/mnt`;
        // per il restore dei dati personali controllo esistenza di is-clone.md
        this.personalFile = `/run/live/medium/live/is-clone.md`;
    }
    /**
     * install
     * @param verbose
     * @param umount
     * @returns
     */
    async install(verbose = false) {
        this.verbose = verbose;
        this.echo = utils_1.default.setEcho(this.verbose);
        if (this.verbose) {
            this.toNull = '';
        }
        // start
        await this.settings.load();
        // partition
        let percent = 0.0;
        let message = "";
        let isPartitioned = false;
        message = "Creating partitions";
        percent = 0.01;
        try {
            await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
            isPartitioned = await this.partition();
        }
        catch (error) {
            await utils_1.default.pressKeyToExit(JSON.stringify(error));
        }
        if (isPartitioned) {
            // formatting
            message = "Formatting file system ";
            percent = 0.02;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.mkfs();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // mountFs
            message = "Mounting target file system ";
            percent = 0.03;
            try {
                redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.mountFs();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // mountVfs
            message = "Mounting on target VFS ";
            percent = 0.06;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.mountVfs();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // unpackfs
            message = "Unpacking filesystem ";
            percent = 0.10;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.unpackfs();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            /**
             * IF RESTORE USERS DATA
             */
            if (fs_1.default.existsSync(this.luksFile)) {
                // restoring users data
                message = "Restore private data from backup ";
                percent = 0.37;
                let cmd = 'eggs syncfrom --rootdir /tmp/calamares-krill-root/';
                try {
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent, spinner: true }));
                    await (0, utils_2.exec)(cmd, utils_1.default.setEcho(true));
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(cmd);
                }
            }
            // sources-yolk
            if (this.distro.familyId === 'debian') {
                message = 'sources-yolk';
                percent = 0.40;
                try {
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent, spinner: true }));
                    await this.execCalamaresModule('sources-yolk');
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(JSON.stringify(error));
                }
            }
            // machineid
            message = 'machineid';
            percent = 0.41;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent, spinner: true }));
                await this.machineId();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // fstab
            message = "Creating fstab ";
            percent = 0.47;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.fstab(this.partitions.installationDevice);
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // locale
            message = "Locale ";
            percent = 0.47;
            try {
                redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.locale();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // keyboard
            message = "settings keyboard ";
            percent = 0.48;
            try {
                this.setKeyboard();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // localeCfg
            message = "localeCfg";
            percent = 0.50;
            try {
                this.localeCfg();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // networkcfg
            message = "networkcfg";
            percent = 0.50;
            try {
                this.networkCfg();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // hostname
            message = "Create hostname ";
            percent = 0.53;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.hostname();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // hosts
            message = "Creating hosts ";
            percent = 0.60;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.hosts();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // bootloader-config
            message = "bootloader-config ";
            percent = 0.62;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.bootloaderConfig();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // grubcfg
            message = "grubcfg ";
            percent = 0.63;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.grubcfg();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // bootloader
            message = "bootloader ";
            percent = 0.64;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.bootloader();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // initramfsCfg
            message = "initramfs configure";
            percent = 0.65;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                this.initramfsCfg(this.partitions.installationDevice);
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // initramfs
            message = "initramfs ";
            percent = 0.67;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.initramfs();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            /**
             * IF NOT RESTORE USERS DATA OR PERSONAL BACKUP
             */
            if (!fs_1.default.existsSync(this.luksFile) || fs_1.default.existsSync(this.personalFile)) {
                // delLiveUser
                message = "Removing user live ";
                percent = 0.70;
                try {
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                    await this.delLiveUser();
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(JSON.stringify(error));
                }
                // addUser
                message = "Adding user ";
                percent = 0.73;
                try {
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                    await this.addUser(this.users.name, this.users.password, this.users.fullname, '', '', '');
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(JSON.stringify(error));
                }
                // changePassword
                message = "adding user password ";
                percent = 0.77;
                try {
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                    await this.changePassword('root', this.users.rootPassword);
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(JSON.stringify(error));
                }
            }
            // autologin
            if (pacman_1.default.isInstalledGui()) {
                try {
                    message = "autologin GUI";
                    percent = 0.80;
                    await xdg_1.default.autologin(utils_1.default.getPrimaryUser(), this.users.name, this.installTarget);
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(JSON.stringify(error));
                }
            }
            else { // autologin CLI remove DEFAULT
                message = "autologin CLI";
                percent = 0.80;
                try {
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                    await cliAutologin.remove(this.installTarget);
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(JSON.stringify(error));
                }
            }
            // cleanup
            await cliAutologin.msgRemove(`${this.installTarget}/etc/motd`);
            await cliAutologin.msgRemove(`${this.installTarget}/etc/issue`);
            // removeInstaller
            message = "remove installer";
            percent = 0.87;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.removeInstallerLink();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // sourcesYolkUmount
            if (this.distro.familyId === 'debian') {
                message = "sources yolk unmount";
                percent = 0.92;
                try {
                    await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                    await this.execCalamaresModule('sources-yolk-unmount');
                }
                catch (error) {
                    await utils_1.default.pressKeyToExit(JSON.stringify(error));
                }
            }
            // umountVfs
            message = "umount VFS";
            percent = 0.95;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.umountVfs();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // umount
            message = "umount";
            percent = 0.97;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.umountFs();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
            // finished
            message = "finished";
            percent = 100.0;
            try {
                await redraw(react_1.default.createElement(install_1.default, { message: message, percent: percent }));
                await this.finished();
            }
            catch (error) {
                await utils_1.default.pressKeyToExit(JSON.stringify(error));
            }
        }
    }
    /**
     *
     */
    async execCalamaresModule(name) {
        const moduleName = this.installer.multiarchModules + name + '/module.desc';
        if (fs_1.default.existsSync(moduleName)) {
            const calamaresModule = js_yaml_1.default.load(fs_1.default.readFileSync(moduleName, 'utf8'));
            let command = calamaresModule.command;
            if (command !== '' || command !== undefined) {
                command += this.toNull;
                await (0, utils_2.exec)(command, this.echo);
            }
        }
    }
    /**
     * only show the result
     */
    async finished() {
        await redraw(react_1.default.createElement(finished_1.default, { installationDevice: this.partitions.installationDevice, hostName: this.users.hostname, userName: this.users.name }));
        utils_1.default.pressKeyToExit('Press a key to reboot...');
        shelljs_1.default.exec('reboot');
    }
}
exports.default = Sequence;
// const ifaces: string[] = fs.readdirSync('/sys/class/net/')
/**
 *
 * @param elem
 */
async function redraw(elem) {
    let opt = {};
    opt.patchConsole = false;
    opt.debug = false;
    console.clear();
    // await exec('clear', Utils.setEcho(false))
    (0, ink_1.render)(elem, opt);
}
