"use strict";
/**
 * https://stackoverflow.com/questions/23876782/how-do-i-split-a-typescript-class-into-multiple-files
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const utils_1 = require("../../lib/utils");
const utils_2 = tslib_1.__importDefault(require("../../classes/utils"));
/**
   * bootloader
   * @param target
   * @param options
   */
async function bootloader() {
    /**
     * update-grub it's just a script:
       #!/bin/sh
       set -e
       exec grub-mkconfig -o /boot/grub/grub.cfg "$@"
     *
     * not present on Arch, so we use grub-mkconfig
     */
    let cmd = `chroot ${this.installTarget} grub-install ${this.partitions.installationDevice} ${this.toNull}`;
    try {
        await (0, utils_1.exec)(cmd, this.echo);
    }
    catch (error) {
        await utils_2.default.pressKeyToExit(cmd);
    }
    cmd = `chroot ${this.installTarget} grub-mkconfig -o /boot/grub/grub.cfg ${this.toNull}`;
    try {
        await (0, utils_1.exec)(cmd, this.echo);
    }
    catch (error) {
        await utils_2.default.pressKeyToExit(cmd);
    }
    await (0, utils_1.exec)(`sleep 1 ${this.toNull}`, this.echo);
    // let echoYes = Utils.setEcho(true)
    // await exec(`chroot ${this.installTarget} grub-install ${this.partitions.installationDevice} ${this.toNull}`, echoYes)
    // await exec(`chroot ${this.installTarget} grub-mkconfig -o /boot/grub/grub.cfg ${this.toNull}`, echoYes)
    // await exec(`sleep 1 ${this.toNull}`, echoYes)
}
exports.default = bootloader;
