"use strict";
/**
 * https://stackoverflow.com/questions/23876782/how-do-i-split-a-typescript-class-into-multiple-files
 */
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const utils_1 = tslib_1.__importDefault(require("../../classes/utils"));
const utils_2 = require("../../lib/utils");
async function setKeyboard() {
    /**
    * influence: - /etc/default/keyboard (x11)
    *            - /etc/vconsole.conf (console)
    *            - /etc/X11/xorg.conf.d/00-keyboard.conf
    *
    * Problem: Actually don't update /etc/default/keyboard (x11)s
    *          /etc/vconsole.conf is update in installed syste,
    */
    // systemd as default
    let cmd = `chroot ${this.installTarget} localectl set-keymap ${this.keyboardLayout}`;
    if (!utils_1.default.isSystemd()) {
        cmd = `chroot ${this.installTarget} setupcon ${this.toNull}`;
    }
    try {
        await (0, utils_2.exec)(cmd, this.echo);
    }
    catch (error) {
        console.log(error);
        utils_1.default.pressKeyToExit(cmd, true);
    }
    /**
     * this must to be not necessary but...
     *
     * force change /etc/default/keyboard (x11)
     * force change /etc/vconsole.conf
     */
    let content = '# KEYBOARD CONFIGURATION FILE\n\n';
    content += '# Consult the keyboard(5) manual page.\n\n';
    content += 'XKBMODEL="' + this.keyboardModel + '"\n';
    content += 'XKBLAYOUT="' + this.keyboardLayout + '"\n';
    content += 'XKBVARIANT="' + this.keyboardVariant + '"\n';
    content += 'XKBOPTIONS=""\n';
    content += '\n';
    content += 'BACKSPACE="guess"\n';
    // Utils.write(this.installTarget + '/etc/default/keyboard', content)
    content = 'KEYMAP=' + +this.keyboardModel + '"\n';
    content += 'FONT=\n';
    content += 'FONT_MAP=\n';
    // Utils.write(this.installTarget + '/etc/vconsole.conf', content)
}
exports.default = setKeyboard;
