'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
//import { option } from '@oclif/command/lib/flags'
const inquirer_1 = tslib_1.__importDefault(require("inquirer"));
async function getPassword(initial) {
    const requireLetterAndNumber = (value) => {
        if (/\w/.test(value) && /\d/.test(value)) {
            return true;
        }
    };
    return new Promise(function (resolve) {
        const questions = [
            {
                type: 'password',
                message: 'Choose a password to keep your account safe: ',
                name: 'password',
                default: initial
                // validate: requireLetterAndNumber,
            },
            {
                type: 'password',
                message: 'Confirm your password: ',
                name: 'confirmPassword',
                default: initial
                // validate: requireLetterAndNumber,
            }
        ];
        inquirer_1.default.prompt(questions).then(function (options) {
            resolve(options.password);
        });
    });
}
exports.default = getPassword;
