"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * penguins-eggs
 * selectKeyboardLayout
 * author: Piero Proietti
 */
const inquirer_1 = tslib_1.__importDefault(require("inquirer"));
const keyboards_1 = tslib_1.__importDefault(require("../classes/keyboards"));
/**
 *
 */
async function selectKeyboardLayout(selected = '') {
    const keyboards = new keyboards_1.default();
    const layouts = keyboards.getLayouts();
    const supported = [];
    for (const l of layouts) {
        supported.push(l.code);
    }
    const questions = [
        {
            type: 'list',
            name: 'layout',
            message: 'Select layout: ',
            choices: supported,
            default: selected
        }
    ];
    return new Promise(function (resolve) {
        inquirer_1.default.prompt(questions).then(function (options) {
            resolve(options.layout);
        });
    });
}
exports.default = selectKeyboardLayout;
