"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * penguins-eggs
 * selectKeyboardModel
 * author: Piero Proietti
 */
const inquirer_1 = tslib_1.__importDefault(require("inquirer"));
const keyboards_1 = tslib_1.__importDefault(require("../classes/keyboards"));
/**
 *
 */
async function selectKeyboardModel(selected = '') {
    const keyboards = new keyboards_1.default();
    const models = keyboards.getModels();
    const supported = [];
    for (const m of models) {
        supported.push(m.code);
    }
    const questions = [
        {
            type: 'list',
            name: 'model',
            message: 'Select model: ',
            choices: supported,
            default: selected
        }
    ];
    return new Promise(function (resolve) {
        inquirer_1.default.prompt(questions).then(function (options) {
            resolve(options.model);
        });
    });
}
exports.default = selectKeyboardModel;
