"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * penguins-eggs
 * selectKeyboardVariant
 * author: Piero Proietti
 */
const inquirer_1 = tslib_1.__importDefault(require("inquirer"));
const keyboards_1 = tslib_1.__importDefault(require("../classes/keyboards"));
/**
 *
 */
async function selectKeyboardVariant(keyboardLayout = '') {
    const keyboards = new keyboards_1.default();
    const variants = keyboards.getVariants(keyboardLayout);
    const supported = [];
    supported.push(''); // inserisce una varian nulla
    for (const v of variants) {
        supported.push(v.code);
    }
    const questions = [
        {
            type: 'list',
            name: 'variant',
            message: 'Select variant: ',
            choices: supported,
            default: ''
        }
    ];
    return new Promise(function (resolve) {
        inquirer_1.default.prompt(questions).then(function (options) {
            resolve(options.variant);
        });
    });
}
exports.default = selectKeyboardVariant;
