"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
/**
 * less /usr/share/i18n/SUPPORTED
 */
const inquirer_1 = tslib_1.__importDefault(require("inquirer"));
const locales_1 = tslib_1.__importDefault(require("../classes/locales"));
async function selectLanguages(selectedLanguage = "") {
    const locales = new locales_1.default();
    const supported = await locales.getSupported();
    const selected = selectedLanguage;
    const questions = [
        {
            type: 'list',
            name: 'language',
            message: 'Select language: ',
            choices: supported,
            default: selected
        }
    ];
    return new Promise(function (resolve) {
        inquirer_1.default.prompt(questions).then(function (options) {
            resolve(options.language);
        });
    });
}
exports.default = selectLanguages;
